import React, { useCallback, useEffect, useRef, useState } from "react";
import styles from "./index.module.scss";
import { Button, DatePicker, Form, FormInstance, Input } from "antd";
import dayjs from "dayjs";
import MyPopconfirm from "@/components/MyPopconfirm";
import ZRichText from "@/components/ZRichText";
import ZupOne from "@/components/ZupOne";
import ZupVideos from "@/components/ZupVideos";
import { MessageFu } from "@/utils/message";
import { A7_APIgetInfo, A7_APIsave } from "@/store/action/A7volunteer";

type Props = {
  editId: number;
  type: string;
  addTableFu: () => void;
  editTableFu: () => void;
  closeFu: () => void;
};

function A7edit({ editId, type, addTableFu, editTableFu, closeFu }: Props) {
  const [dirCode, setDirCode] = useState("");

  // 表单的ref
  const FormBoxRef = useRef<FormInstance>(null);

  // 封面图的ref
  const ZupThumbRef = useRef<any>(null);
  // 富文本的ref
  const ZRichTextRef = useRef<any>(null);
  //  视频的ref
  const ZupVideosRef = useRef<any>(null);

  const getInfoFu = useCallback(async (id: number) => {
    const res = await A7_APIgetInfo(id);
    if (res.code === 0) {
      const entity = res.data.entity;
      const file = res.data.file;

      setDirCode(entity.dirCode);

      ZRichTextRef.current?.ritxtShowFu(entity.rtf);

      FormBoxRef.current?.setFieldsValue({
        ...entity,
        myTime: dayjs(entity.publishDate),
      });

      // 设置封面图
      ZupThumbRef.current?.setFileComFileFu({
        fileName: "",
        filePath: entity.thumb,
      });

      // 设置附件视频
      ZupVideosRef.current?.setFileComFileFu(file || []);
    }
  }, []);

  useEffect(() => {
    if (editId > 0) {
      getInfoFu(editId);
    } else {
      setDirCode(Date.now() + "");
      FormBoxRef.current?.setFieldsValue({
        myTime: dayjs(Date.now()),
      });
    }
  }, [editId, getInfoFu]);

  // 附件 是否 已经点击过确定
  const [fileCheck, setFileCheck] = useState(false);

  // 没有通过校验
  const onFinishFailed = useCallback(() => {
    setFileCheck(true);
  }, []);

  //  通过校验点击确定
  const onFinish = useCallback(
    async (values: any) => {
      setFileCheck(true);

      const coverUrl1 = ZupThumbRef.current?.fileComFileResFu();
      // 没有传 封面图
      if (!coverUrl1.filePath) return MessageFu.warning("请上传封面图!");
      // 发布日期
      const publishDate = dayjs(values.myTime).format("YYYY-MM-DD");

      const rtf = ZRichTextRef.current?.fatherBtnOkFu();

      const flieList = ZupVideosRef.current?.fileComFileResFu() || [];

      const obj = {
        ...values,
        id: editId > 0 ? editId : null,
        publishDate,
        thumb: coverUrl1.filePath,
        rtf: rtf.val || "",
        fileIds: flieList.map((v: any) => v.id).join(","),
        type,
      };

      const res = await A7_APIsave(obj);

      if (res.code === 0) {
        MessageFu.success(editId > 0 ? "编辑成功!" : "新增成功!");
        editId > 0 ? editTableFu() : addTableFu();
        closeFu();
      }
    },
    [addTableFu, closeFu, editId, editTableFu, type]
  );
  return (
    <div className={styles.A7edit}>
      <div className="A7eMain">
        <Form
          ref={FormBoxRef}
          name="basic"
          labelCol={{ span: 3 }}
          onFinish={onFinish}
          onFinishFailed={onFinishFailed}
          autoComplete="off"
          scrollToFirstError
        >
          <Form.Item
            label="标题"
            name="name"
            rules={[{ required: true, message: "请输入标题!" }]}
            getValueFromEvent={(e) => e.target.value.replace(/\s+/g, "")}
          >
            <Input maxLength={30} showCount placeholder="请输入内容" />
          </Form.Item>

          <Form.Item
            label="发布日期"
            name="myTime"
            rules={[{ required: true, message: "请选择发布日期!" }]}
          >
            <DatePicker />
          </Form.Item>

          {/* 所属栏目 */}
          <div className="formRow">
            <div className="formLeft">
              <span>* </span>
              所属栏目：
            </div>
            <div className="formRight formRightTxt">{type}</div>
          </div>
          <br />

          {/* 封面 */}
          <div className="formRow">
            <div className="formLeft">
              <span>* </span>
              封面图：
            </div>
            <div className="formRight">
              <ZupOne
                ref={ZupThumbRef}
                isLook={false}
                fileCheck={fileCheck}
                size={5}
                dirCode={dirCode}
                myUrl="cms/volunteer/upload"
                format={["image/jpeg", "image/png"]}
                formatTxt="png、jpg和jpeg"
                checkTxt="请上传封面图!"
                upTxt="最多1张"
                myType="thumb"
              />
            </div>
          </div>

          {/* 视频 */}
          <div className="formRow">
            <div className="formLeft">视频：</div>
            <div className="formRight">
              <ZupVideos
                isLook={false}
                size={500}
                fileNum={5}
                dirCode={dirCode}
                myUrl="cms/overview/upload"
                upTxt="；数量不超过5个。"
                ref={ZupVideosRef}
              />
            </div>
          </div>

          {/* 富文本 */}
          <div className="formRow">
            <div className="formLeft">正文：</div>
            <div className="formRight" style={{ height: 450 }}>
              <ZRichText
                check={false}
                dirCode={dirCode}
                isLook={false}
                ref={ZRichTextRef}
                myUrl="cms/volunteer/upload"
              />
            </div>
          </div>

          {/* 确定和取消按钮 */}
          <Form.Item className="A7Ebtn">
            <Button type="primary" htmlType="submit">
              提交
            </Button>
            <br />
            <br />
            <MyPopconfirm txtK="取消" onConfirm={closeFu} />
          </Form.Item>
        </Form>
      </div>
    </div>
  );
}

const MemoA7edit = React.memo(A7edit);

export default MemoA7edit;
